// Env.cs
using System;
using System.Collections;


namespace TtLisp {
  public class Env {
    // -- instance -------------------------------------------------------
    private Stack         symbolStack;
    private FunctionTable functionTable;

    public Env() {
      this.symbolStack = new Stack();
      this.symbolStack.Push( new SymbolTable() );

      this.functionTable = new FunctionTable();
    }

    public SymbolicExpression Eval( SymbolicExpression s ) { return s; }

    private Stack SymbolStack { get { return this.symbolStack; } }
    public SymbolTable SymbolTable {
      get { return (SymbolTable)this.SymbolStack.Peek(); }
    }
    public void PushStack() {
      this.SymbolStack.Push( new SymbolTable( this.SymbolTable ) );
    }
    public void PopStack() {
      this.SymbolStack.Pop();
    }

    public FunctionTable FunctionTable {
      get { return this.functionTable; }
    }

  }
}
