// Numeric.cs
using System;

namespace TtLisp {
  public abstract class Numeric : Atom {}

  public class Integer : Numeric {
    // -- instance -------------------------------------------------------
    private int val;

    public Integer() : this( 0 ) {}
    public Integer( int i )  { this.val = i; }

    public int Value { get { return this.val; } }

    public Integer add( Integer other ) {
      return new Integer( this.val + other.val );
    }
    public Integer sub( Integer other ) {
      return new Integer( this.val - other.val );
    }
    public Integer mul( Integer other ) {
      return new Integer( this.val * other.val );
    }
    public Integer div( Integer other ) {
      return new Integer( this.val / other.val );
    }
    public Integer mod( Integer other ) {
      return new Integer( this.val % other.val );
    }

    public SymbolicExpression eq( Integer other ) {
      return this.val == other.val ? True.T : SymbolicExpression.NIL;
    }
    public SymbolicExpression ne( Integer other ) {
      return this.val != other.val ? True.T : SymbolicExpression.NIL;
    }
    public SymbolicExpression gt( Integer other ) {
      return this.val > other.val ? True.T : SymbolicExpression.NIL;
    }
    public SymbolicExpression lt( Integer other ) {
      return this.val < other.val ? True.T : SymbolicExpression.NIL;
    }
    public SymbolicExpression ge( Integer other ) {
      return this.val >= other.val ? True.T : SymbolicExpression.NIL;
    }
    public SymbolicExpression le( Integer other ) {
      return this.val <= other.val ? True.T : SymbolicExpression.NIL;
    }

  }
}
